<form [formGroup]="form" style="width: 100%; max-width: 800px; margin: 0 auto;">

  <mat-form-field appearance="fill" style="width: 100%;">
    <mat-label>Library Name</mat-label>
    <input matInput type="text" formControlName="name" placeholder="e.g., DB1_SpectralLibrary">
  </mat-form-field>

  <div>
    <!-- Divider + expansion-button -->
    <div style="display: flex; align-items:center; width:100%;">
      <div class="divider-line" style="width:100%;">Advanced Parameters</div>
      <button style="display: inline-block;" mat-icon-button [disabled]="!runSpecLibPrediction" (click)="expandSpecLibPredictionParams = !expandSpecLibPredictionParams">
        <mat-icon [@indicatorRotate]="expandSpecLibPredictionParams && runSpecLibPrediction ? 'expanded' : 'collapsed'">
          expand_more
        </mat-icon>
      </button>
    </div>

    <!-- TODO -->
    <div [@detailExpand]="expandSpecLibPredictionParams && runSpecLibPrediction ? 'expanded' : 'collapsed'"
         style="height:100%; width:100%; overflow: hidden; margin-bottom: 1em">

      <div formGroupName="ms2pipParams" style="padding: 0 16px;">

        <div fxLayout="row wrap" fxLayoutGap="16px">
          <mat-form-field fxFlex="45" appearance="fill">
            <mat-label>Minimum Peptide Length</mat-label>
            <input matInput type="number" formControlName="minLength" placeholder="7">
          </mat-form-field>

          <mat-form-field fxFlex="45" appearance="fill">
            <mat-label>Maximum Peptide Length</mat-label>
            <input matInput type="number" formControlName="maxLength" placeholder="30">
          </mat-form-field>

          <mat-form-field fxFlex="45" appearance="fill">
            <mat-label>Missed Cleavages</mat-label>
            <input matInput type="number" formControlName="missedCleavages" placeholder="2">
          </mat-form-field>

          <mat-form-field fxFlex="45" appearance="fill">
            <mat-label>Max Variable Modifications</mat-label>
            <input matInput type="number" formControlName="maxVariableModifications" placeholder="3">
          </mat-form-field>
        </div>

        <div fxLayout="row wrap" fxLayoutGap="16px">
          <mat-form-field fxFlex="93" style="max-height: 56px" appearance="fill">
            <mat-label>Cleavage Rule</mat-label>
            <mat-select formControlName="cleavageRule">
              <mat-option value="trypsin">Trypsin</mat-option>
            </mat-select>
          </mat-form-field>
        </div>
        <div fxLayout="row wrap" fxLayoutGap="16px">

          <mat-form-field fxFlex="93" appearance="fill">
            <mat-label>Charges</mat-label>
            <mat-chip-grid #chipList aria-label="Charges">
              <mat-chip-row
                *ngFor="let charge of chargesArray; let i = index"
                [removable]="true"
                (removed)="removeCharge(i)"
              >
                {{ charge }}
                <mat-icon matChipRemove>cancel</mat-icon>
              </mat-chip-row>
              <input
                matInput
                placeholder="Add a charge"
                [formControl]="chargeInput"
                (matChipInputTokenEnd)="addCharge($event)"
                [matChipInputFor]="chipList"
                [matChipInputSeparatorKeyCodes]="separatorKeysCodes"
                [matChipInputAddOnBlur]="true"
              />
            </mat-chip-grid>
          </mat-form-field>
        </div>

        <mat-divider style="margin-top: 16px; margin-bottom: 16px;"></mat-divider>
        <h3>Modifications</h3>
        <div formArrayName="modifications">
          <div
            class="modification-group"
            [formGroupName]="i"
            *ngFor="let modification of modifications.controls; let i = index"
            style="margin-bottom: 8px;"
          >
            <div fxLayout="row wrap" fxLayoutAlign="start center" fxLayoutGap="16px">
              <mat-form-field fxFlex="45" appearance="fill">
                <mat-label>Modification Label</mat-label>
                <input matInput type="text" formControlName="label" placeholder="UNIMOD:Oxidation">
              </mat-form-field>

              <mat-form-field fxFlex="20" appearance="fill">
                <mat-label>Amino Acid</mat-label>
                <input matInput type="text" formControlName="aminoAcid" maxlength="1" placeholder="M">
              </mat-form-field>

              <mat-checkbox fxFlex="10" formControlName="fixed">Fixed</mat-checkbox>

              <button
                mat-icon-button
                color="warn"
                (click)="removeModification(i)"
                matTooltip="Remove modification"
                fxLayoutAlign="end center"
              >
                <mat-icon>delete</mat-icon>
              </button>
            </div>
          </div>

          <button
            mat-raised-button
            color="primary"
            (click)="addModification()"
            style="margin-top: 8px;"
          >
            <mat-icon>add</mat-icon> Add Modification
          </button>
        </div>
      </div>
    </div>
  </div>

</form>
